// VisAnDlg.cpp : implementation file
//

#include "stdafx.h"
#include "VisAn.h"
#include "VisAnDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CVisAnDlg dialog
extern char cmdline[80];
CVisAnDlg::CVisAnDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CVisAnDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CVisAnDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CVisAnDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CVisAnDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CVisAnDlg, CDialog)
	//{{AFX_MSG_MAP(CVisAnDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CVisAnDlg message handlers

BOOL CVisAnDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	max = 0;
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	if (cmdline[0])
	{	
		if (!(f = fopen(cmdline,"r")))
			{
				MessageBox("Parameter is not a file name path", "Error opening file", MB_OK|MB_ICONERROR);
				exit(1);
			}
	}
	else 
	{
		MessageBox("Parameter is not a file name path", "Error", MB_OK|MB_ICONERROR);
		exit(1);
	}
	/*else if (!(f = fopen("c:\\test1.txt","r")))
	{
		MessageBox("Error opening file", "Error opening file", MB_OK|MB_ICONERROR);
	}*/

	unsigned a;
	for(int i = 0; i < 35; i++)
		for(int j = 0; j < 52; j++)
		{	
			if ((fscanf(f, "%d", &a)))
			{
				if (a > max) {
					max = a;
				}
				field[j][i] = a;
			}
			else
			{
				MessageBox("Wrong file format", "Error", MB_OK|MB_ICONERROR);
				exit(1);
			}
		}
	fclose(f);
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CVisAnDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		COLORREF farba;
		CPaintDC dc(this);
		for(int i = 0; i < 52; i++)
			for (int j = 0;j < 35;j++)
			{
				int a;
//				int a = (unsigned)((float)(field[i][j]));
				float floatfield = (float)field[i][j];
				a = (int)(floatfield / max * 256.0f);
				farba = 0x00ffffff - a*256*256 - a*256 - a;
				dc.FillSolidRect(15*i,15*j, 15*(i+1), 15*(j+1) , farba);
			}
		POINT points[4];
		points[0].x = points[0].y = 0;
		points[1].x = 0;
		points[1].y = 15*35;
		points[2].x = 15*52;
		points[2].y = 0;
		points[3].x = 15*52;
		points[3].y = 15*35;
		
		dc.MoveTo(points[0]);
		dc.LineTo(points[1]);
		dc.MoveTo(points[1]);
		dc.LineTo(points[3]);
		dc.MoveTo(points[3]);
		dc.LineTo(points[2]);
		dc.MoveTo(points[2]);
		dc.LineTo(points[0]);
		dc.MoveTo(15*26, 0);
		dc.LineTo(15*26, 15*35);

		CDialog::OnPaint();
	}
}

HCURSOR CVisAnDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}
